use Gtk;
init Gtk;

sub get_widget_name ($) {
	my $widgets = shift;
	my $this_widget = shift;
	foreach (keys %{$widgets}) {
		return $_ if $widgets->{$_} == $this_widget;
	}
	return undef;
}

sub connect_signals ($$@) {
	my ($widgets, $signal, $function, @data) = @_;
	foreach (@data) {
		$widgets->{$_}->signal_connect($signal, $function);
	}
}

sub new {
    my $class = shift;

    my $widgets;
		my $row_height = 4;
    #
    # Construct a GtkWindow 'acidrip'
    $widgets->{'acidrip'} = new Gtk::Window;
    $widgets->{'acidrip'}->set_title('acidrip');
    $widgets->{'acidrip'}->set_policy(0, 0, 1);
    $widgets->{'acidrip'}->realize;
		#
		# Construct a GtkVBox 'status_vbox'
		$widgets->{'status_vbox'} = new Gtk::VBox; #(0, 0);
		$widgets->{'acidrip'}->add($widgets->{'status_vbox'});
		$widgets->{'status_vbox'}->show;		

		$widgets->{'main_table'} = new Gtk::Table(10, 2, 0);
		$widgets->{'main_table'}->show;

		# Construct a GtkHBox 'main_hbox'
		$widgets->{'main_hbox'} = new Gtk::HBox(0, 0);
		$widgets->{'status_vbox'}->add($widgets->{'main_hbox'});
		$widgets->{'main_hbox'}->show;
		#
	  # Construct a GtkVBox 'left_vbox'
	  $widgets->{'left_vbox'} = new Gtk::VBox(0, 0);
	  $widgets->{'main_hbox'}->add($widgets->{'left_vbox'});
	  $widgets->{'left_vbox'}->show;		
		#
	  # Construct a GtkVBox 'notebook_vbox'
	  $widgets->{'notebook_vbox'} = new Gtk::VBox(0, 0);
	  $widgets->{'notebook_vbox'}->show;
		#
		# notebook
		$widgets->{'notebook'} = new Gtk::Notebook();
		$widgets->{'notebook'}->show;
		$widgets->{'notebook'}->border_width(2);
		$widgets->{'left_vbox'}->add($widgets->{'notebook'});
		$widgets->{'notebook'}->append_page($widgets->{'notebook_vbox'}, new Gtk::Label("General"));

			
### GENERAL FRAME			
			
		# Construct a GtkFrame 'general_frame'
		$widgets->{'general_frame'} = new Gtk::Frame('General');
		$widgets->{'general_frame'}->set_shadow_type('etched_in');
		$widgets->{'notebook_vbox'}->add($widgets->{'general_frame'});
		$widgets->{'general_frame'}->show;
		$widgets->{'general_frame'}->border_width(2);
		#
		# Construct a GtkTable 'general_table'
		$widgets->{'general_table'} = new Gtk::Table(5, 3, 0);
		$widgets->{'general_frame'}->add($widgets->{'general_table'});
		$widgets->{'general_table'}->row_spacing($row_height);
		$widgets->{'general_table'}->show;
		#
		# Construct a GtkLabel 'filename_label'
		$widgets->{'filename_label'} = new Gtk::Label('File name');
		$widgets->{'general_table'}->attach($widgets->{'filename_label'}, 0, 1, 0, 1, ['fill'], [], 2, 2);
		$widgets->{'filename_label'}->show;			
		#
		# Construct a GtkEntry 'filename'
		$widgets->{'directory_filename_entry'} = new Gtk::Entry;
		$widgets->{'directory_filename_entry'}->show;
		$widgets->{'directory_filename_entry'}->set_usize(10,0);
		$widgets->{'general_table'}->attach($widgets->{'directory_filename_entry'}, 1, 4, 0, 1, ['fill'], [], 2, 2);
		
		$widgets->{'directory_entry'} = new Gtk::Entry;
		$widgets->{'filename_entry'} = new Gtk::Entry;

		$widgets->{'filetype_button'} = new Gtk::Entry;
		$widgets->{'filetype_button'}->set_text(".avi");
		$widgets->{'filetype_button'}->set_editable(0);
		$widgets->{'filetype_button'}->show;			
		$widgets->{'filetype_button'}->set_usize(10,0);
		$widgets->{'general_table'}->attach($widgets->{'filetype_button'}, 4, 5, 0, 1, ['fill'], [], 2, 2);			
			
		# Construct a GtkLabel 'filesize_label'
		$widgets->{'filesize_label'} = new Gtk::Label('File size');
		$widgets->{'general_table'}->attach($widgets->{'filesize_label'}, 0, 1, 1, 2, ['fill'], [], 2, 2);
		$widgets->{'filesize_label'}->show;
		$widgets->{'filesize_label'}->set_alignment(0, 0);
		#
		# Construct a GtkCombo 'filesize_combo'			
		$widgets->{'filesize_adjust'} = new Gtk::Adjustment(1, 1, 9999, 1, 1, 1);
		$widgets->{'filesize_spin'} = new Gtk::SpinButton($widgets->{'filesize_adjust'}, 1, 0);
		$widgets->{'filesize_spin'}->set_usize(40,0);
		$widgets->{'general_table'}->attach($widgets->{'filesize_spin'}, 1, 2, 1, 2, ['expand', 'fill'], [], 2, 2);
		$widgets->{'filesize_spin'}->show;
			
		$widgets->{'total_blocks_label'} = new Gtk::Label("No. of Files");
		$widgets->{'general_table'}->attach($widgets->{'total_blocks_label'}, 2, 4, 1, 2, ['fill'], [], 2, 2);
		$widgets->{'total_blocks_label'}->show;
			
		$widgets->{'total_blocks_adjust'} = new Gtk::Adjustment(1, 1, 10, 1, 1, 1);
		$widgets->{'total_blocks_spin'} = new Gtk::SpinButton($widgets->{'total_blocks_adjust'}, 1, 0);
		$widgets->{'general_table'}->attach($widgets->{'total_blocks_spin'}, 4, 5, 1, 2, [ 'fill'], [], 2, 2);			
		$widgets->{'total_blocks_spin'}->show;
		
		$widgets->{'total_blocks_spin'}->set_usize(40,0);
		
		$widgets->{'info_label'} = new Gtk::Label('Info');
		$widgets->{'general_table'}->attach($widgets->{'info_label'}, 0, 1, 2, 3, [ 'fill'], [], 2, 2);
		$widgets->{'info_label'}->set_alignment(0,0);
		$widgets->{'info_label'}->show;

		$widgets->{'info_field_combo'} = new Gtk::Combo;
		$widgets->{'info_field_combo'}->set_popdown_strings('name','artist','subject','genre','copyright');
		$widgets->{'general_table'}->attach($widgets->{'info_field_combo'}, 1, 2, 2, 3, [ 'fill'], [], 2, 2);
		$widgets->{'info_field_combo'}->set_usize(40, 0);
		$widgets->{'info_field_combo'}->show;
			
		$widgets->{'info_field_entry'} = $widgets->{'info_field_combo'}->entry;

		$widgets->{'info_name_entry'} = new Gtk::Entry;
		$widgets->{'general_table'}->attach($widgets->{'info_name_entry'}, 2, 5, 2, 3, [ 'fill'], [], 2, 2);
		$widgets->{'info_name_entry'}->set_usize(40, 0);
		$widgets->{'info_name_entry'}->show;
			
		$widgets->{'info_artist_entry'} = new Gtk::Entry;
		$widgets->{'general_table'}->attach($widgets->{'info_artist_entry'}, 2, 5, 2, 3, [ 'fill'], [], 2, 2);
		$widgets->{'info_artist_entry'}->set_usize(40, 0);

		$widgets->{'info_subject_entry'} = new Gtk::Entry;
		$widgets->{'general_table'}->attach($widgets->{'info_subject_entry'}, 2, 5, 2, 3, [ 'fill'], [], 2, 2);
		$widgets->{'info_subject_entry'}->set_usize(40, 0);
			
		$widgets->{'info_genre_entry'} = new Gtk::Entry;
		$widgets->{'general_table'}->attach($widgets->{'info_genre_entry'}, 2, 5, 2, 3, [ 'fill'], [], 2, 2);
		$widgets->{'info_genre_entry'}->set_usize(40, 0);
			
		$widgets->{'info_copyright_entry'} = new Gtk::Entry;
		$widgets->{'general_table'}->attach($widgets->{'info_copyright_entry'}, 2, 5, 2, 3, [ 'fill'], [], 2, 2);
		$widgets->{'info_copyright_entry'}->set_usize(40, 0);
		
		$widgets->{'info_comment_entry'} = new Gtk::Entry;
		$widgets->{'general_table'}->attach($widgets->{'info_comment_entry'}, 2, 5, 2, 3, [ 'fill'], [], 2, 2);
		$widgets->{'info_comment_entry'}->set_usize(40, 0);
			
		$widgets->{'notebook_vbox'}->set_child_packing($widgets->{'general_frame'}, 1, 1, 0, 'start');

### AUDIO FRAME
		
		# Construct a GtkFrame 'audio_frame'
		$widgets->{'audio_frame'} = new Gtk::Frame('Audio');
		$widgets->{'audio_frame'}->set_shadow_type('etched_in');
		$widgets->{'notebook_vbox'}->add($widgets->{'audio_frame'});
		$widgets->{'audio_frame'}->show;
		$widgets->{'audio_frame'}->border_width(2);
		#
		# Construct a GtkTable 'audio_table'
		$widgets->{'audio_table'} = new Gtk::Table(3, 5, 0);
		$widgets->{'audio_frame'}->add($widgets->{'audio_table'});
		$widgets->{'audio_table'}->row_spacing($row_height);
		$widgets->{'audio_table'}->show;
		#
		# Construct a GtkLabel 'language_label'
		$widgets->{'audio_track_label'} = new Gtk::Label('Language');
		$widgets->{'audio_table'}->attach($widgets->{'audio_track_label'}, 0, 1, 0, 1, ['fill'], [], 2, 2);
		$widgets->{'audio_track_label'}->show;
		$widgets->{'audio_track_label'}->set_alignment(0, 0.5);
		#
		# Construct a GtkCombo 'language_combo'
		$widgets->{'audio_track_combo'} = new Gtk::Combo;
		$widgets->{'audio_table'}->attach($widgets->{'audio_track_combo'}, 1, 5, 0, 1, ['expand', 'fill'], [], 2, 2);
		$widgets->{'audio_track_combo'}->show;
		#
		# Construct a GtkEntry 'language_entry'
		$widgets->{'audio_track_entry'} = $widgets->{'audio_track_combo'}->entry;
		$widgets->{'audio_track_entry'}->show;
		$widgets->{'audio_track_entry'}->set_visibility(1);
		$widgets->{'audio_track_entry'}->set_editable(0);
		#
		# Construct a GtkLabel 'audio_options_label'
		$widgets->{'audio_options_label'} = new Gtk::Label('Options');
		$widgets->{'audio_table'}->attach($widgets->{'audio_options_label'}, 0, 1, 2, 3, ['fill'], [], 2, 2);
		$widgets->{'audio_options_label'}->show;
		$widgets->{'audio_options_label'}->set_alignment(0, 0.5);
			
		$widgets->{'audio_options_entry'} = new Gtk::Entry;
		$widgets->{'audio_table'}->attach($widgets->{'audio_options_entry'}, 1, 5, 2, 3, ['fill'], [], 2, 2);
		$widgets->{'audio_options_entry'}->show;
		$widgets->{'audio_options_entry'}->set_usize(50, 0);

		# Construct a GtkLabel 'audio_codec_label'
		$widgets->{'audio_codec_label'} = new Gtk::Label('Codec');
		$widgets->{'audio_table'}->attach($widgets->{'audio_codec_label'}, 0, 1, 1, 2, ['fill'], [], 2, 2);
		$widgets->{'audio_codec_label'}->show;
		$widgets->{'audio_codec_label'}->set_alignment(0, 0.5);
		#
		# Construct a GtkCombo 'audio_codec_combo'
		$widgets->{'audio_codec_combo'} = new Gtk::Combo;
		$widgets->{'audio_table'}->attach($widgets->{'audio_codec_combo'}, 1, 5, 1, 2, ['expand', 'fill'], [], 2, 2);
		$widgets->{'audio_codec_combo'}->show;		
		$widgets->{'audio_codec_combo'}->set_usize(50, 0);

		#
		# Construct a GtkEntry 'audio_codec_combo_entry'
		$widgets->{'audio_codec_entry'} = $widgets->{'audio_codec_combo'}->entry;
		$widgets->{'audio_codec_entry'}->show;
		$widgets->{'left_vbox'}->set_child_packing($widgets->{'audio_frame'}, 1, 1, 0, 'start');
		
		$widgets->{'mp3_type_label'} = new Gtk::Label("Type");
		#$widgets->{'mp3_type_label'}->show;
		$widgets->{'audio_table'}->attach($widgets->{'mp3_type_label'}, 3, 4, 1, 2, ['fill'], [], 2, 2);
		$widgets->{'mp3_type_label'}->set_alignment(0, 0.5);

		$widgets->{'mp3_type_combo'} = new Gtk::Combo;
		$widgets->{'audio_table'}->attach($widgets->{'mp3_type_combo'}, 4, 5, 1, 2, ['fill'], [], 2, 2);
		$widgets->{'mp3_type_combo'}->set_popdown_strings('abr', 'cbr', 'vbr');
		#$widgets->{'mp3_type_combo'}->show;
		$widgets->{'mp3_type_combo'}->set_usize(50, 0);

		$widgets->{'mp3_bitrate_label'} = new Gtk::Label("Bitrate");
		#$widgets->{'mp3_bitrate_label'}->show;
		$widgets->{'audio_table'}->attach($widgets->{'mp3_bitrate_label'}, 3, 4, 2, 3, ['fill'], [], 2, 2);
		$widgets->{'mp3_bitrate_label'}->set_alignment(0, 0.5);

		$widgets->{'mp3_bitrate_entry'} = new Gtk::Entry;
		#$widgets->{'mp3_bitrate_entry'}->show;
		$widgets->{'audio_table'}->attach($widgets->{'mp3_bitrate_entry'}, 4, 5, 2, 3, ['fill'], [], 2, 2);
		$widgets->{'mp3_bitrate_entry'}->set_usize(50,0);

		$widgets->{'mp3_quality_label'} = new Gtk::Label("Quality");
		#$widgets->{'mp3_quality_label'}->show;
		$widgets->{'audio_table'}->attach($widgets->{'mp3_quality_label'}, 3, 4, 2, 3, ['fill'], [], 2, 2);
		$widgets->{'mp3_quality_label'}->set_alignment(0, 0.5);

		$widgets->{'mp3_quality_entry'} = new Gtk::Entry;
		#$widgets->{'mp3_quality_entry'}->show;
		$widgets->{'audio_table'}->attach($widgets->{'mp3_quality_entry'}, 4, 5, 2, 3, ['fill'], [], 2, 2);
		$widgets->{'mp3_quality_entry'}->set_usize(50,0);

### SUBTITLES

		$widgets->{'misc_table'} = new Gtk::Table(4,2,0);
		$widgets->{'misc_table'}->show;
		$widgets->{'misc_table'}->row_spacing($row_height);

		$widgets->{'misc_frame'} = new Gtk::Frame("Other stuff");
		$widgets->{'misc_frame'}->add($widgets->{'misc_table'});
		$widgets->{'notebook_vbox'}->add($widgets->{'misc_frame'});
		$widgets->{'misc_frame'}->show;
		$widgets->{'misc_frame'}->border_width(2);

		$widgets->{'subp_label'} = new Gtk::Label('Subtitle ');
		$widgets->{'subp_label'}->show;
		$widgets->{'misc_table'}->attach($widgets->{'subp_label'}, 0, 1, 0, 1, ['fill'], [], 4, 2);
			
		$widgets->{'subp_combo'} = new Gtk::Combo;
		$widgets->{'subp_combo'}->show;
		$widgets->{'subp_combo'}->set_usize(10,0);
		$widgets->{'subp_entry'} = $widgets->{'subp_combo'}->entry;
		$widgets->{'misc_table'}->attach($widgets->{'subp_combo'}, 1, 3, 0, 1, ['fill', 'expand'], [], 2, 2);
		
		$widgets->{'vobsubout_check'} = new Gtk::CheckButton('Sub File');
		$widgets->{'vobsubout_check'}->show;
		$widgets->{'vobsubout_check'}->set_usize(10,0);
		$widgets->{'misc_table'}->attach($widgets->{'vobsubout_check'}, 3, 4, 0, 1, ['fill', 'expand'], [], 2, 2);
		
		$widgets->{'more_options_entry'} = new Gtk::Entry;
		$widgets->{'more_options_entry'}->show;
		$widgets->{'more_options_label'} = new Gtk::Label("Misc.");
		$widgets->{'more_options_label'}->set_alignment(0, 0.5);
		$widgets->{'more_options_label'}->show;
			
		$widgets->{'misc_table'}->attach($widgets->{'more_options_label'}, 0, 1, 1, 2, ['fill'], [], 4, 2);
		$widgets->{'misc_table'}->attach($widgets->{'more_options_entry'}, 1, 4, 1, 2, ['fill', 'expand'], [], 2, 2);

### VIDEO 

		# Construct a GtkFrame 'video_frame'
		$widgets->{'video_frame'} = new Gtk::Frame('Video');
		$widgets->{'video_frame'}->set_label_align(0, 0);
		$widgets->{'notebook'}->append_page($widgets->{'video_frame'}, new Gtk::Label("Video"));
		$widgets->{'video_frame'}->show;
		$widgets->{'video_frame'}->border_width(2);
		#
		# Construct a GtkTable 'video_table'
		$widgets->{'video_table'} = new Gtk::Table(10, 5, 0);
		$widgets->{'video_table'}->row_spacing($row_height);
		$widgets->{'video_frame'}->add($widgets->{'video_table'});
		$widgets->{'video_table'}->show;
			
		$widgets->{'video_crop_seperator'} = new Gtk::HSeparator;
		$widgets->{'video_crop_seperator'}->show;
		$widgets->{'video_table'}->attach($widgets->{'video_crop_seperator'}, 0, 5, 3, 4, ['fill'], [], 2, 2);
		#
		# Construct a GtkCheckButton 'crop_enable_check'
		$widgets->{'crop_enable_check'} = new Gtk::CheckButton("Crop");
		$widgets->{'video_table'}->attach($widgets->{'crop_enable_check'}, 0, 1, 4, 5, ['fill'], [], 2, 2);
		$widgets->{'crop_enable_check'}->show;
		#
		# Construct a GtkEntry 'crop_vertical_entry'
		$widgets->{'crop_vertical_adjust'} = new Gtk::Adjustment(0, 0, 720, 1, 50, 200);
		$widgets->{'crop_vertical_spin'} = new Gtk::SpinButton($widgets->{'crop_vertical_adjust'}, 1, 0);
		$widgets->{'video_table'}->attach($widgets->{'crop_vertical_spin'}, 4, 5, 5, 6, ['expand', 'fill'], [], 2, 2);
		$widgets->{'crop_vertical_spin'}->show;
		$widgets->{'crop_vertical_spin'}->set_usize(40, 0);
		#
		# Construct a GtkEntry 'crop_horizontal_entry'
		$widgets->{'crop_horizontal_adjust'} = new Gtk::Adjustment(0, 0, 576, 1, 50, 200 );
		$widgets->{'crop_horizontal_spin'} = new Gtk::SpinButton($widgets->{'crop_horizontal_adjust'}, 1, 0);
		$widgets->{'video_table'}->attach($widgets->{'crop_horizontal_spin'}, 4, 5, 4, 5, ['expand', 'fill'], [], 2, 2);
		$widgets->{'crop_horizontal_spin'}->show;
		$widgets->{'crop_horizontal_spin'}->set_usize(40, 0);
		#
		# Construct a GtkEntry 'crop_width_entry'
		$widgets->{'crop_width_adjust'} = new Gtk::Adjustment(0, 0, 1000, 1, 50, 200 );
		$widgets->{'crop_width_spin'} = new Gtk::SpinButton($widgets->{'crop_width_adjust'}, 1, 0);
		$widgets->{'video_table'}->attach($widgets->{'crop_width_spin'}, 2, 3, 4, 5, ['expand', 'fill'], [], 2, 2);
		$widgets->{'crop_width_spin'}->show;
		$widgets->{'crop_width_spin'}->set_usize(40, 0);
		#
		# Construct a GtkEntry 'crop_height_entry'
		$widgets->{'crop_height_adjust'} = new Gtk::Adjustment(0, 0, 1000, 1, 50, 200 );
		$widgets->{'crop_height_spin'} = new Gtk::SpinButton($widgets->{'crop_height_adjust'}, 1, 0);
		$widgets->{'video_table'}->attach($widgets->{'crop_height_spin'}, 2, 3, 5, 6, ['expand', 'fill'], [], 2, 2);
		$widgets->{'crop_height_spin'}->show;
		$widgets->{'crop_height_spin'}->set_usize(40, 0);
		#
		# Construct a GtkLabel 'crop_vertical_label'
		$widgets->{'crop_vertical_label'} = new Gtk::Label('Vert');
		$widgets->{'video_table'}->attach($widgets->{'crop_vertical_label'}, 3, 4, 5, 6, ['fill'], [], 2, 2);
		$widgets->{'crop_vertical_label'}->show;
		#
		# Construct a GtkLabel 'crop_horizontal_label'
		$widgets->{'crop_horizontal_label'} = new Gtk::Label('Horiz');
		$widgets->{'video_table'}->attach($widgets->{'crop_horizontal_label'}, 3, 4, 4, 5, ['fill'], [], 2, 2);
		$widgets->{'crop_horizontal_label'}->show;
		#
		# Construct a GtkLabel 'crop_width_label'
		$widgets->{'crop_width_label'} = new Gtk::Label('Width');
		$widgets->{'video_table'}->attach($widgets->{'crop_width_label'}, 1, 2, 4, 5, ['fill'], [], 2, 2);
		$widgets->{'crop_width_label'}->show;
		#
		# Construct a GtkLabel 'crop_height_label'
		$widgets->{'crop_height_label'} = new Gtk::Label('Height');
		$widgets->{'video_table'}->attach($widgets->{'crop_height_label'}, 1, 2, 5, 6, ['fill'], [], 2, 2);
		$widgets->{'crop_height_label'}->show;
		#
		# Construct a GtkButton 'crop_detect_button'
		$widgets->{'crop_detect_button'} = new Gtk::Button('Detect');
		$widgets->{'video_table'}->attach($widgets->{'crop_detect_button'}, 0, 1, 5, 6, ['fill'], [], 2, 2);
		$widgets->{'crop_detect_button'}->show;
		
		$widgets->{'video_scale_seperator'} = new Gtk::HSeparator;
		$widgets->{'video_scale_seperator'}->show;
		$widgets->{'video_table'}->attach($widgets->{'video_scale_seperator'}, 0, 5, 6, 7, ['fill'], [], 2, 2);
					
		# Construct a GtkCheckButton 'scale_enable_check'
		$widgets->{'scale_enable_check'} = new Gtk::CheckButton('Scale');
		$widgets->{'video_table'}->attach($widgets->{'scale_enable_check'}, 0, 1, 7, 8, ['fill'], [], 2, 2);
		$widgets->{'scale_enable_check'}->show;
		#
		# Construct a GtkLabel 'scale_width_label'
		$widgets->{'scale_width_label'} = new Gtk::Label('Width');
		$widgets->{'video_table'}->attach($widgets->{'scale_width_label'}, 1, 2, 7, 8, ['fill'], [], 2, 2);
		$widgets->{'scale_width_label'}->show;
		#
		# Construct a GtkLabel 'scale_height_label'
		$widgets->{'scale_lock_check'} = new Gtk::CheckButton('Lock aspect');
		$widgets->{'video_table'}->attach($widgets->{'scale_lock_check'}, 3, 5, 7, 8, ['fill'], [], 2, 2);
		$widgets->{'scale_lock_check'}->set_relief('none');
		$widgets->{'scale_lock_check'}->show;
		$widgets->{'scale_lock_check'}->set_active(1);
			    
		$widgets->{'scale_height_label'} = new Gtk::Label('Height');
		$widgets->{'video_table'}->attach($widgets->{'scale_height_label'}, 1, 2, 8, 9, ['fill'], [], 2, 2);
		$widgets->{'scale_height_label'}->show;
		#
		# Construct a GtkEntry 'scale_width_entry'
		$widgets->{'scale_width_adjust'} = new Gtk::Adjustment(1, -2, 1000, 1, 50, 200 );
		$widgets->{'scale_width_spin'} = new Gtk::SpinButton($widgets->{'scale_width_adjust'}, 1, 0);
		$widgets->{'video_table'}->attach($widgets->{'scale_width_spin'}, 2, 3, 7, 8, ['expand', 'fill'], [], 2, 2);
		$widgets->{'scale_width_spin'}->show;
		$widgets->{'scale_width_spin'}->set_usize(50, 0);
		#
		# Construct a GtkEntry 'scale_height_entry'
		$widgets->{'scale_height_adjust'} = new Gtk::Adjustment($::settings->{'scale_height'}, -2, 1000, 1, 50, 200 );
		$widgets->{'scale_height_spin'} = new Gtk::SpinButton($widgets->{'scale_height_adjust'}, 1, 0);
		$widgets->{'video_table'}->attach($widgets->{'scale_height_spin'}, 2, 3, 8, 9, ['expand', 'fill'], [], 2, 2);
		$widgets->{'scale_height_spin'}->hide;
		$widgets->{'scale_height_spin'}->set_usize(50, 0);
					
		$widgets->{'scale_height_estimate_entry'} = new Gtk::Entry;
		$widgets->{'scale_height_estimate_entry'}->set_text("0");
		$widgets->{'video_table'}->attach($widgets->{'scale_height_estimate_entry'}, 2, 3, 8, 9, ['expand', 'fill'], [], 2, 2);
		$widgets->{'scale_height_estimate_entry'}->set_editable(0);
		$widgets->{'scale_height_estimate_entry'}->show;
		$widgets->{'scale_height_estimate_entry'}->set_usize(50, 0);

		$widgets->{'video_filters_seperator'} = new Gtk::HSeparator;
		$widgets->{'video_filters_seperator'}->show;
		$widgets->{'video_table'}->attach($widgets->{'video_filters_seperator'}, 0, 5, 9, 10, ['fill'], [], 2, 2);
		
		$widgets->{'vop_pre_enable_check'} = new Gtk::CheckButton("Pre filters");
		$widgets->{'video_table'}->attach($widgets->{'vop_pre_enable_check'}, 0, 2, 10, 11, ['expand', 'fill'], [], 2, 2);
		$widgets->{'vop_pre_enable_check'}->show;

		$widgets->{'vop_pre_entry'} = new Gtk::Entry;
		$widgets->{'vop_pre_entry'}->set_usize(40, 0);
		$widgets->{'video_table'}->attach($widgets->{'vop_pre_entry'}, 2, 5, 10, 11, ['expand', 'fill'], [], 2, 2);
		$widgets->{'vop_pre_entry'}->show;

		$widgets->{'vop_post_enable_check'} = new Gtk::CheckButton("Post filters");
		$widgets->{'video_table'}->attach($widgets->{'vop_post_enable_check'}, 0, 2, 11, 12, ['expand', 'fill'], [], 2, 2);
		$widgets->{'vop_post_enable_check'}->show;
		
		$widgets->{'vop_post_entry'} = new Gtk::Entry;
		$widgets->{'video_table'}->attach($widgets->{'vop_post_entry'}, 2, 5, 11, 12, ['expand', 'fill'], [], 2, 2);
		$widgets->{'vop_post_entry'}->show;
		$widgets->{'vop_post_entry'}->set_usize(40, 0);

		# Construct a GtkLabel 'codec_label'
		$widgets->{'codec_label'} = new Gtk::Label('Codec');
		$widgets->{'video_table'}->attach($widgets->{'codec_label'}, 0, 1, 0, 1, ['fill'], [], 2, 2);
		$widgets->{'codec_label'}->show;
		$widgets->{'codec_label'}->set_alignment(0, 0.5);
		#
		# Construct a GtkCombo 'codec_combo'
		$widgets->{'video_codec_combo'} = new Gtk::Combo;
		$widgets->{'video_codec_combo'}->set_value_in_list(1,0);
		$widgets->{'video_table'}->attach($widgets->{'video_codec_combo'}, 1, 3, 0, 1, ['expand', 'fill'], [], 2, 2);
		$widgets->{'video_codec_combo'}->show;
		$widgets->{'video_codec_combo'}->set_usize(40,0);
	  #
	  # Construct a GtkEntry 'codec_combo_entry'
	  $widgets->{'video_codec_entry'} = $widgets->{'video_codec_combo'}->entry;
	  $widgets->{'video_codec_entry'}->show;
		#
		# Construct a GtkLabel 'lavc_label'
		$widgets->{'video_options_label'} = new Gtk::Label('Options');
		$widgets->{'video_table'}->attach($widgets->{'video_options_label'}, 0, 1, 1, 2, ['fill'], [], 2, 2);
		$widgets->{'video_options_label'}->show;
		$widgets->{'video_options_label'}->set_alignment(0, 0.5);
		#
		# Construct a GtkEntry 'codec_options_entry'
		$widgets->{'video_options_entry'} = new Gtk::Entry;
		$widgets->{'video_table'}->attach($widgets->{'video_options_entry'}, 1, 5, 1, 2, ['expand', 'fill'], [], 2, 2);
		$widgets->{'video_options_entry'}->show;
		
	  $widgets->{'video_bitrate_label'} = new Gtk::Label('Bitrate');
	  $widgets->{'video_bitrate_label'}->show;
		$widgets->{'video_bitrate_label'}->set_alignment(0, 0.5);
		$widgets->{'video_table'}->attach($widgets->{'video_bitrate_label'}, 0, 1, 2, 3, ['fill'], [], 2, 2);

    $widgets->{'video_bitrate_entry'} = new Gtk::Entry;
	  $widgets->{'video_bitrate_entry'}->show;
		$widgets->{'video_bitrate_entry'}->set_usize(40,0);
		$widgets->{'video_table'}->attach($widgets->{'video_bitrate_entry'}, 1, 2, 2, 3, ['fill'], [], 2, 2);

	  $widgets->{'video_bitrate_lock_check'} = new Gtk::CheckButton('Lock');
	  $widgets->{'video_bitrate_lock_check'}->show;
	  $widgets->{'video_table'}->attach($widgets->{'video_bitrate_lock_check'}, 2, 3, 2, 3, ['fill'], [], 2, 2);
			
		$widgets->{'video_2pass_check'} = new Gtk::CheckButton("2 pass");
		$widgets->{'video_2pass_check'}->show;
		$widgets->{'video_table'}->attach($widgets->{'video_2pass_check'}, 3, 5, 0, 1, ['fill'], [], 2, 2);
			
		$widgets->{'video_bpp_label'} = new Gtk::Label("Bits/Pixel");
		$widgets->{'video_bpp_label'}->show;
		$widgets->{'video_bpp_entry'} = new Gtk::Entry;
		$widgets->{'video_bpp_entry'}->show;
		$widgets->{'video_bpp_entry'}->set_editable(0);
		$widgets->{'video_bpp_entry'}->set_usize(40,0);
		$widgets->{'video_table'}->attach($widgets->{'video_bpp_label'}, 3, 4, 2, 3, ['fill'], [], 2, 2);
		$widgets->{'video_table'}->attach($widgets->{'video_bpp_entry'}, 4, 5, 2, 3, ['fill'], [], 2, 2);
		
		# Construct a GtkVBox 'right_vbox'
	  $widgets->{'right_vbox'} = new Gtk::VBox(0, 0);
	  $widgets->{'main_hbox'}->add($widgets->{'right_vbox'});
	  $widgets->{'right_vbox'}->show;

		### DVD TREE
			
		# Construct a GtkFrame 'dvd_tree_frame'
		$widgets->{'dvd_tree_frame'} = new Gtk::Frame('DVD contents');
		$widgets->{'dvd_tree_frame'}->set_label_align(0, 0);
		$widgets->{'right_vbox'}->add($widgets->{'dvd_tree_frame'});
		$widgets->{'dvd_tree_frame'}->show;
		$widgets->{'dvd_tree_frame'}->border_width(2);
		#
		# Construct a GtkVBox 'dvd_tree_vbox'
		$widgets->{'dvd_tree_vbox'} = new Gtk::VBox(0, 0);
		$widgets->{'dvd_tree_frame'}->add($widgets->{'dvd_tree_vbox'});
		$widgets->{'dvd_tree_vbox'}->show;
		#
		# Construct a GtkHBox 'dvd_device_hbox'
		$widgets->{'dvd_device_hbox'} = new Gtk::HBox(0, 0);
		$widgets->{'dvd_tree_vbox'}->add($widgets->{'dvd_device_hbox'});
		$widgets->{'dvd_device_hbox'}->show;
		#
		# Construct a GtkLabel 'dvd_device'
		$widgets->{'dvd_device_label'} = new Gtk::Label('Device');
		$widgets->{'dvd_device_hbox'}->add($widgets->{'dvd_device_label'});
		$widgets->{'dvd_device_label'}->show;
		$widgets->{'dvd_device_label'}->set_alignment(0.5, 0.5);
		$widgets->{'dvd_device_label'}->set_padding(2, 2);
		$widgets->{'dvd_device_hbox'}->set_child_packing($widgets->{'dvd_device_label'}, 0, 0, 0, 'start');
		#
		# Construct a GtkEntry 'dvd_device_entry'
		$widgets->{'dvd_device_entry'} = new Gtk::Entry;
		$widgets->{'dvd_device_hbox'}->add($widgets->{'dvd_device_entry'});
		$widgets->{'dvd_device_entry'}->show;
		$widgets->{'dvd_device_entry'}->set_usize(100, 0);
		$widgets->{'dvd_device_hbox'}->set_child_packing($widgets->{'dvd_device_entry'}, 0, 0, 0, 'start');
		#
		# Construct a GtkButton 'read_dvd_button'
		$widgets->{'read_dvd_button'} = new Gtk::Button('Reload');
		$widgets->{'dvd_device_hbox'}->add($widgets->{'read_dvd_button'});
		$widgets->{'read_dvd_button'}->show;
		$widgets->{'read_dvd_button'}->border_width(2);
		$widgets->{'dvd_device_hbox'}->set_child_packing($widgets->{'read_dvd_button'}, 1, 1, 0, 'start');
		$widgets->{'dvd_tree_vbox'}->set_child_packing($widgets->{'dvd_device_hbox'}, 0, 0, 0, 'start');
		#
		# Construct a GtkScrolledWindow 'tree_scroll_window'
		$widgets->{'tree_scroll_window'} = new Gtk::ScrolledWindow( undef, undef);
		$widgets->{'tree_scroll_window'}->set_policy('never', 'always');
		$widgets->{'tree_scroll_window'}->border_width(2);
		$widgets->{'dvd_tree_vbox'}->add($widgets->{'tree_scroll_window'});
		$widgets->{'tree_scroll_window'}->show;
		#
		# Construct a GtkTree 'dvd_tree'
		$widgets->{'dvd_tree'} = new Gtk::Tree;
		$widgets->{'dvd_tree'}->set_selection_mode('multiple');
		$widgets->{'dvd_tree'}->set_view_mode('line');
		$widgets->{'dvd_tree'}->set_view_lines(1);
		$widgets->{'tree_scroll_window'}->add_with_viewport($widgets->{'dvd_tree'});
		$widgets->{'dvd_tree'}->show;
		$widgets->{'dvd_tree'}->set_usize(200, 0);
		$widgets->{'dvd_tree_vbox'}->set_child_packing($widgets->{'tree_scroll_window'}, 1, 1, 0, 'start');
		$widgets->{'right_vbox'}->set_child_packing($widgets->{'dvd_tree_frame'}, 1, 1, 0, 'start');
		
		$widgets->{'selected_track_label'} = new Gtk::Label("No track selected");
		$widgets->{'dvd_tree_vbox'}->pack_end($widgets->{'selected_track_label'}, 0, 1, 2);
		$widgets->{'selected_track_label'}->show;
		$widgets->{'selected_track_label'}->set_alignment(0,0);
		
		$widgets->{'cache_menc_vbox'} = new Gtk::VBox();
		$widgets->{'right_vbox'}->pack_start($widgets->{'cache_menc_vbox'}, 0, 0, 0);
		$widgets->{'cache_menc_vbox'}->show;
		
### CACHE FRAME
		
		# Construct a GtkFrame 'cache_frame'
		$widgets->{'cache_frame'} = new Gtk::Frame('Cache');
		$widgets->{'cache_menc_vbox'}->pack_start($widgets->{'cache_frame'}, 0, 0, 2);
		$widgets->{'cache_frame'}->show;
		$widgets->{'cache_frame'}->border_width(2);
		#
		# Construct a GtkTable 'mencoder_table' 
		$widgets->{'cache_table'} = new Gtk::Table(1, 4, 1);
		$widgets->{'cache_frame'}->add($widgets->{'cache_table'});
		$widgets->{'cache_table'}->show;
		
		$widgets->{'cache_chapter_label'} = new Gtk::Label("Chapter:");
		$widgets->{'cache_chapter_label'}->show;
		$widgets->{'cache_chapter_label'}->set_alignment(0, 0.5);
		$widgets->{'cache_table'}->attach($widgets->{'cache_chapter_label'}, 0, 1, 0, 1, ['fill'], [], 2, 2);
		
		$widgets->{'cache_chapter'} = new Gtk::Label("0 (0/0)");
		$widgets->{'cache_chapter'}->show;
		$widgets->{'cache_table'}->attach($widgets->{'cache_chapter'}, 1, 2, 0, 1, ['fill'], [], 2, 2);
		
		$widgets->{'cache_size_label'} = new Gtk::Label("Size:");
		$widgets->{'cache_size_label'}->show;		
		$widgets->{'cache_size_label'}->set_alignment(0, 0.5);
		$widgets->{'cache_table'}->attach($widgets->{'cache_size_label'}, 2, 3, 0, 1, ['fill'], [], 2, 2);		

		$widgets->{'cache_size'} = new Gtk::Label("0mb");
		$widgets->{'cache_size'}->show;
		$widgets->{'cache_table'}->attach($widgets->{'cache_size'}, 3, 4, 0, 1, ['fill'], [], 2, 2);		
		
### MENCODER FRAME

		# Construct a GtkFrame 'menc_frame'
		$widgets->{'menc_frame'} = new Gtk::Frame('Encoding status');
		$widgets->{'cache_menc_vbox'}->add($widgets->{'menc_frame'});
		#$widgets->{'main_table'}->attach($widgets->{'menc_frame'}, 1, 2, 4, 6, ['fill'], ['fill'], 2, 2);
		$widgets->{'menc_frame'}->show;
		$widgets->{'menc_frame'}->border_width(2);
		#
		# Construct a GtkTable 'mencoder_table'
		$widgets->{'mencoder_table'} = new Gtk::Table(6, 2, 0);
		$widgets->{'menc_frame'}->add($widgets->{'mencoder_table'});
		$widgets->{'mencoder_table'}->show;
		#
		# Construct a GtkLabel 'menc_fps_label'
		$widgets->{'menc_fps_label'} = new Gtk::Label('Encoding speed:');
		$widgets->{'mencoder_table'}->attach($widgets->{'menc_fps_label'}, 0, 1, 1, 2, ['fill'], [], 2, 1);
		$widgets->{'menc_fps_label'}->show;
		$widgets->{'menc_fps_label'}->set_alignment(0, 0.5);
		#
		# Construct a GtkLabel 'menc_time_label'
		$widgets->{'menc_time_label'} = new Gtk::Label('Time Left:');
		$widgets->{'mencoder_table'}->attach($widgets->{'menc_time_label'}, 0, 1, 0, 1, ['fill'], [], 2, 1);
		$widgets->{'menc_time_label'}->show;
		$widgets->{'menc_time_label'}->set_alignment(0, 0.5);
		#
		# Construct a GtkLabel 'menc_filesize_label'
		$widgets->{'menc_filesize_label'} = new Gtk::Label('Estimated filesize:');
		$widgets->{'mencoder_table'}->attach($widgets->{'menc_filesize_label'}, 0, 1, 2, 3, ['fill'], [], 2, 1);
		$widgets->{'menc_filesize_label'}->show;
		$widgets->{'menc_filesize_label'}->set_alignment(0, 0.5);
		#
		# Construct a GtkLabel 'menc_progress_label'
		$widgets->{'menc_progress_label'} = new Gtk::Label('Seconds encoded:');
		$widgets->{'mencoder_table'}->attach($widgets->{'menc_progress_label'}, 0, 1, 3, 4, ['fill'], [], 2, 1);
		$widgets->{'menc_progress_label'}->show;
		$widgets->{'menc_progress_label'}->set_alignment(0, 0.5);
		#
		# Construct a GtkLabel 'progress_value'
		$widgets->{'menc_seconds'} = new Gtk::Label('0.0s');
		$widgets->{'mencoder_table'}->attach($widgets->{'menc_seconds'}, 1, 2, 3, 4, ['expand', 'fill'], [], 2, 1);
		$widgets->{'menc_seconds'}->show;
		$widgets->{'menc_seconds'}->set_alignment(0.5, 0.5);
		#
		# Construct a GtkLabel 'menc_progress_label'
		$widgets->{'menc_bitrate_label'} = new Gtk::Label('Average bitrates:');
		$widgets->{'mencoder_table'}->attach($widgets->{'menc_bitrate_label'}, 0, 1, 4, 5, ['fill'], [], 2, 1);
		$widgets->{'menc_bitrate_label'}->show;
		$widgets->{'menc_bitrate_label'}->set_alignment(0, 0.5);
					
		$widgets->{'menc_bitrate'} = new Gtk::Label('0:0');
		$widgets->{'mencoder_table'}->attach($widgets->{'menc_bitrate'}, 1, 2, 4, 5, ['expand', 'fill'], [], 2, 1);
		$widgets->{'menc_bitrate'}->show;
		$widgets->{'menc_bitrate'}->set_alignment(0.5, 0.5);
		#
		# Construct a GtkLabel 'filesize'
		$widgets->{'menc_filesize'} = new Gtk::Label('0mb');
		$widgets->{'mencoder_table'}->attach($widgets->{'menc_filesize'}, 1, 2, 2, 3, ['expand', 'fill'], [], 2, 1);
		$widgets->{'menc_filesize'}->show;
		$widgets->{'menc_filesize'}->set_alignment(0.5, 0.5);
		#
		# Construct a GtkLabel 'fps'
		$widgets->{'menc_fps'} = new Gtk::Label('0fps');
		$widgets->{'mencoder_table'}->attach($widgets->{'menc_fps'}, 1, 2, 1, 2, ['expand', 'fill'], [], 2, 1);
		$widgets->{'menc_fps'}->show;
		$widgets->{'menc_fps'}->set_alignment(0.5, 0.5);
		#
		# Construct a GtkLabel 'time'
		$widgets->{'menc_time'} = new Gtk::Label('0min');
		$widgets->{'mencoder_table'}->attach($widgets->{'menc_time'}, 1, 2, 0, 1, ['expand', 'fill'], [], 2, 1);
		$widgets->{'menc_time'}->show;
		$widgets->{'menc_time'}->set_alignment(0.5, 0.5);
		#$widgets->{'mencoder_vbox'}->set_child_packing($widgets->{'mencoder_table'}, 1, 1, 0, 'start');
		#
		# Construct a GtkProgressBar 'progress'
		$widgets->{'menc_progress'} = new Gtk::ProgressBar;
		$widgets->{'menc_progress'}->set_orientation('left_to_right');
		$widgets->{'menc_progress'}->set_bar_style('continuous');
		$widgets->{'menc_progress'}->set_show_text(1);
		$widgets->{'menc_progress'}->set_activity_mode(0);
		$widgets->{'menc_progress'}->set_text_alignment(0.5, 0.5);
		$widgets->{'menc_progress'}->set_format_string('%P %%');
		$widgets->{'menc_progress'}->configure(0, 0, 100);
		$widgets->{'mencoder_table'}->attach($widgets->{'menc_progress'}, 0, 2, 5, 6, ['fill'], [], 2, 2);
		$widgets->{'menc_progress'}->show;
		$widgets->{'right_vbox'}->set_child_packing($widgets->{'menc_frame'}, 0, 1, 0, 'start');

		$widgets->{'control_table'} = new Gtk::Table(2, 2, 1);
		$widgets->{'control_table'}->show;
		
		$widgets->{'right_vbox'}->pack_end($widgets->{'control_table'}, 0, 1, 0);
		$widgets->{'right_vbox'}->set_child_packing($widgets->{'control_table'}, 0, 1, 0, 'start');
		
### BUTTONS

		# Construct a GtkHBox 'settings_hbox'
		$widgets->{'buttons_table'} = new Gtk::Table(2, 2, 1);
		$widgets->{'left_vbox'}->add($widgets->{'buttons_table'});
		$widgets->{'buttons_table'}->show;
		#
		# Construct a GtkButton 'quit_button'
		$widgets->{'quit_button'} = new Gtk::Button('Quit');
		$widgets->{'buttons_table'}->attach($widgets->{'quit_button'}, 1, 2, 1, 2, ['expand', 'fill'], [], 2, 2);
		$widgets->{'quit_button'}->show;
		#
		# Construct a GtkButton 'progress_dialog_show_button'
		$widgets->{'progress_dialog_show_button'} = new Gtk::Button('Compact view');
		$widgets->{'buttons_table'}->attach($widgets->{'progress_dialog_show_button'}, 0, 1, 1, 2, ['expand', 'fill'], [], 2, 2);
		$widgets->{'progress_dialog_show_button'}->show;
		$widgets->{'progress_dialog_show_button'}->set_sensitive(0);
		#
    # Construct a GtkButton 'start_button'
    $widgets->{'start_button'} = new Gtk::Button('Start');
    $widgets->{'buttons_table'}->attach($widgets->{'start_button'}, 1, 2, 0, 1, ['expand', 'fill'], [], 2, 2);
    $widgets->{'start_button'}->show;
		$widgets->{'start_button'}->set_sensitive(0);
   	    
		#
		# Construct a GtkButton 'stop_button'
		$widgets->{'stop_button'} = new Gtk::Button('Stop');
		$widgets->{'buttons_table'}->attach($widgets->{'stop_button'}, 1, 2, 0, 1, ['expand', 'fill'], [], 2, 2);
		#
		# Construct a GtkButton 'stop_button'
		$widgets->{'view_button'} = new Gtk::Button('View');
		$widgets->{'buttons_table'}->attach($widgets->{'view_button'}, 0, 1, 0, 1, ['expand', 'fill'], [], 2, 2);
		$widgets->{'view_button'}->show;
		$widgets->{'view_button'}->set_sensitive(0);
	  $widgets->{'main_hbox'}->set_child_packing($widgets->{'right_vbox'}, 1, 1, 0, 'end');

### PREVIEW TAB
		
		$widgets->{'preview_frame'} = new Gtk::Frame("Preview");
		$widgets->{'preview_frame'}->border_width(2);
		$widgets->{'preview_table'} = new Gtk::Table(2, 5, 0);		
		$widgets->{'preview_table'}->row_spacing($row_height);
		$widgets->{'preview_frame'}->add($widgets->{'preview_table'});
		$widgets->{'notebook'}->append_page($widgets->{'preview_frame'}, new Gtk::Label("Preview"));
		$widgets->{'preview_socket'} = new Gtk::Socket;
		$widgets->{'preview_table'}->attach($widgets->{'preview_socket'}, 0, 2, 0, 1, ['expand', 'fill'], ['expand'], 2, 2);
		$widgets->{'preview_socket'}->realize;
		#$widgets->{'preview_socket'}->set_usize(100,200);
		$widgets->{'preview_table'}->attach(new Gtk::VBox, 0, 2, 1, 2, ['expand', 'fill'], ['expand', 'fill'], 2, 2);
		$widgets->{'preview_table'}->attach(new Gtk::HSeparator, 0, 2, 2, 3, ['expand', 'fill'], [], 2, 2);
		#
	  # Construct a GtkButton 'preview_button'
		$widgets->{'preview_button'} = new Gtk::Button('Preview');
		$widgets->{'preview_button'}->set_sensitive(0);
		$widgets->{'preview_table'}->attach($widgets->{'preview_button'}, 0, 2, 4, 5, ['expand', 'fill'], [], 2, 2);
		#
	  # Construct a GtkButton 'preview_button'
		$widgets->{'stop_preview_button'} = new Gtk::Button('Stop');
		$widgets->{'preview_table'}->attach($widgets->{'stop_preview_button'}, 0, 2, 4, 5, ['expand', 'fill'], [], 2, 2);
		#
		# Construct a GtkCHECK 'flickbook_preview_check'
		$widgets->{'flickbook_preview_check'} = new Gtk::CheckButton("Flickbook");
		$widgets->{'preview_table'}->attach($widgets->{'flickbook_preview_check'}, 1, 2, 3, 4, ['fill'], [], 2, 2 );
		#
		$widgets->{'embed_preview_check'} = new Gtk::CheckButton("Embed");
		$widgets->{'preview_table'}->attach($widgets->{'embed_preview_check'}, 0, 1, 3, 4, ['fill'], [], 2, 2 );
		
		$widgets->{'preview_frame'}->show_all;
		
### ADDITIONAL SETTINGS
		
    # Construct a GtkDialog 'additional_settings_dialog'
    $widgets->{'additional_settings_frame'} = new Gtk::Frame("AcidRip settings");
		$widgets->{'additional_settings_frame'}->show;
		$widgets->{'additional_settings_frame'}->border_width(2);
		$widgets->{'notebook'}->append_page($widgets->{'additional_settings_frame'}, new Gtk::Label("Settings"));
		#
		# Construct a GtkVBox 'additional_settings_vbox'
		$widgets->{'additional_settings_vbox'} = new Gtk::VBox; #$widgets->{'additional_settings_dialog'}->vbox;
		$widgets->{'additional_settings_frame'}->add($widgets->{'additional_settings_vbox'});
		$widgets->{'additional_settings_vbox'}->show;
	  #
	  # Construct a GtkTable 'additional_settings_table'
	  $widgets->{'additional_settings_table'} = new Gtk::Table(10, 4, 1 );
	  $widgets->{'additional_settings_vbox'}->add($widgets->{'additional_settings_table'});
	  $widgets->{'additional_settings_table'}->show;		
		$widgets->{'additional_settings_table'}->row_spacing($row_height);
		#
		# Construst a GtkCheckButton 'autoload_check'
		$widgets->{'tooltips_check'} = new Gtk::CheckButton('Use tooltips');
		$widgets->{'additional_settings_table'}->attach($widgets->{'tooltips_check'}, 2, 4, 6, 7, ['fill'], [], 2, 0);
		$widgets->{'tooltips_check'}->show;
		#
		# Construst a GtkCheckButton 'autoload_check'
		$widgets->{'autoload_check'} = new Gtk::CheckButton('Autoload DVD');
		$widgets->{'additional_settings_table'}->attach($widgets->{'autoload_check'}, 0, 2, 5, 6, ['fill'], [], 2, 0);
		$widgets->{'autoload_check'}->show;
		#
		# Construst a GtkCheckButton 'autoload_check'
		$widgets->{'del_cache_check'} = new Gtk::CheckButton('Delete Cache');
		$widgets->{'additional_settings_table'}->attach($widgets->{'del_cache_check'}, 2, 4, 4, 5, ['fill'], [], 2, 0);
		$widgets->{'del_cache_check'}->show;
		#
		# Construst a GtkCheckButton 'autoload_check'
		$widgets->{'overwrite_check'} = new Gtk::CheckButton('Overwrite files');
		$widgets->{'additional_settings_table'}->attach($widgets->{'overwrite_check'}, 0, 2, 6, 7, ['fill'], [], 2, 0);
		$widgets->{'overwrite_check'}->show;
		#
		# Construct a GtkLabel 'mencoder_label'
		$widgets->{'mencoder_label'} = new Gtk::Label('MEncoder:');
		$widgets->{'additional_settings_table'}->attach($widgets->{'mencoder_label'}, 0, 2, 0, 1, ['fill'], [], 2, 2 );
		$widgets->{'mencoder_label'}->show;
		$widgets->{'mencoder_label'}->set_alignment(0, 0.5 );
		#
		# Construct a GtkEntry 'mencoder_entry'
		$widgets->{'mencoder_entry'} = new Gtk::Entry;
		$widgets->{'mencoder_entry'}->set_usize(40,0);
		$widgets->{'additional_settings_table'}->attach($widgets->{'mencoder_entry'}, 2, 4, 0, 1, ['expand', 'fill'], [], 2, 2 );
		$widgets->{'mencoder_entry'}->show;
		#
		# Construct a GtkLabel 'mplayer_label'
		$widgets->{'mplayer_label'} = new Gtk::Label('MPlayer:');
		$widgets->{'additional_settings_table'}->attach($widgets->{'mplayer_label'}, 0, 2, 1, 2, ['fill'], [], 2, 2 );
		$widgets->{'mplayer_label'}->show;
		$widgets->{'mplayer_label'}->set_alignment(0, 0.5 );
		#
		# Construct a GtkEntry 'mplayer_entry'
		$widgets->{'mplayer_entry'} = new Gtk::Entry;
		$widgets->{'mplayer_entry'}->set_usize(40,0);
		$widgets->{'additional_settings_table'}->attach($widgets->{'mplayer_entry'}, 2, 4, 1, 2, ['expand', 'fill'], [], 2, 2 );
		$widgets->{'mplayer_entry'}->show;
		#
		# Construct a GtkLabel 'lsdvd_label'
		$widgets->{'lsdvd_label'} = new Gtk::Label('lsdvd:');
		$widgets->{'additional_settings_table'}->attach($widgets->{'lsdvd_label'}, 0, 2, 2, 3, ['fill'], [], 2, 2 );
		$widgets->{'lsdvd_label'}->show;
		$widgets->{'lsdvd_label'}->set_alignment(0, 0.5 );
		#
		# Construct a GtkEntry 'lsdvd_entry'
		$widgets->{'lsdvd_entry'} = new Gtk::Entry;
		$widgets->{'lsdvd_entry'}->set_usize(40,0);
		$widgets->{'additional_settings_table'}->attach($widgets->{'lsdvd_entry'}, 2, 4, 2, 3, ['expand', 'fill'], [], 2, 2 );
		$widgets->{'lsdvd_entry'}->show;
		#
		# Construct a GtkCHECK 'cache_check'
		$widgets->{'cache_check'} = new Gtk::CheckButton("Cache DVD");
		$widgets->{'additional_settings_table'}->attach($widgets->{'cache_check'}, 0, 2, 4, 5, ['fill'], [], 2, 2 );
		$widgets->{'cache_check'}->show;
		#
		# Construct a GtkLabel 'lsdvd_label'
		$widgets->{'cache_label'} = new Gtk::Label('Cache:');
		$widgets->{'additional_settings_table'}->attach($widgets->{'cache_label'}, 0, 2, 3, 4, ['fill'], [], 2, 2 );
		$widgets->{'cache_label'}->show;
		$widgets->{'cache_label'}->set_alignment(0, 0.5);
		#
		# Construct a GtkEntry for cache location
		$widgets->{'cache_directory_entry'}  = new Gtk::Entry;
		$widgets->{'cache_directory_entry'}->set_usize(40,0);
		$widgets->{'additional_settings_table'}->attach($widgets->{'cache_directory_entry'}, 2, 4, 3, 4, ['fill'], [], 2, 2 );
		$widgets->{'cache_directory_entry'}->show;
		#
		# Construct a GtkLabel for default language
		$widgets->{'language_label'} = new Gtk::Label("Language");
		$widgets->{'additional_settings_table'}->attach($widgets->{'language_label'}, 2, 3, 5, 6, ['fill'], [], 2, 2 );
		$widgets->{'language_label'}->set_alignment(0,0.5);
		$widgets->{'language_label'}->set_usize(1,0);
		$widgets->{'language_label'}->show;
		#
		# Construct a GtkEntry for default language
		$widgets->{'language_entry'} = new Gtk::Entry;
		$widgets->{'additional_settings_table'}->attach($widgets->{'language_entry'}, 3, 4, 5, 6, ['fill'], [], 2, 2 );
		$widgets->{'language_entry'}->set_usize(10,0);
		$widgets->{'language_entry'}->show;
		#
		# Construct a GtkCHECK 'compact_check'
		$widgets->{'compact_check'} = new Gtk::CheckButton("Compact box");
		$widgets->{'additional_settings_table'}->attach($widgets->{'compact_check'}, 0, 2, 7, 8, ['fill'], [], 2, 2 );
		$widgets->{'compact_check'}->show;
		#
		# Construct a GtkCHECK 'enforce_size_check'
		$widgets->{'enforce_space_check'} = new Gtk::CheckButton("Enforce size");
		$widgets->{'additional_settings_table'}->attach($widgets->{'enforce_space_check'}, 2, 4, 7, 8, ['fill'], [], 2, 2 );
		$widgets->{'enforce_space_check'}->show;
		#
		# Construct a GtkCHECK 'ppc_bug_check'
		$widgets->{'ppc_bug_check'} = new Gtk::CheckButton("PPC cropping");
		$widgets->{'additional_settings_table'}->attach($widgets->{'ppc_bug_check'}, 0, 2, 8, 9, ['fill'], [], 2, 2 );
		$widgets->{'ppc_bug_check'}->show;
		#
		# Construct a GtkButton 'save_button'
		$widgets->{'save_button'} = new Gtk::Button('Save settings');
		$widgets->{'additional_settings_table'}->attach($widgets->{'save_button'}, 0, 2, 9, 10, ['expand', 'fill'], [], 2, 2);
		$widgets->{'save_button'}->show;
		#
		# Construct a GtkButton 'restore_button'
		$widgets->{'restore_button'} = new Gtk::Button('Restore defaults');
		$widgets->{'additional_settings_table'}->attach($widgets->{'restore_button'}, 2, 4, 9, 10, ['expand', 'fill'], [], 2, 2);
		$widgets->{'restore_button'}->show;
		
	  $widgets->{'main_hbox'}->set_child_packing($widgets->{'left_vbox'}, 1, 1, 0, 'start');
		
### DEBUG WINDOW
		
		# Construct a mencoder output frame
		$widgets->{'mencoder_output_frame'} = new Gtk::Frame("Output log");
		$widgets->{'mencoder_output_frame'}->border_width(2);
		$widgets->{'status_vbox'}->add($widgets->{'mencoder_output_frame'});
		
		$widgets->{'output_vbox'} = new Gtk::VBox;
		$widgets->{'output_vbox'}->show;
		#
		# Construct a mencoder output table
		$widgets->{'mencoder_output_table'} = new Gtk::Table(4, 1, 0);
		$widgets->{'mencoder_output_frame'}->add($widgets->{'output_vbox'});
		$widgets->{'output_vbox'}->pack_start($widgets->{'mencoder_output_table'}, 0, 0, 2);
		#
		# construct a save button for mencoder output
		$widgets->{'mencoder_output_save_button'} = new_with_label Gtk::Button("Save");
		$widgets->{'mencoder_output_table'}->attach($widgets->{'mencoder_output_save_button'}, 0, 1, 0, 1, ['fill', 'expand'], [], 2, 2);

		$widgets->{'mencoder_output_clear_button'} = new_with_label Gtk::Button("Clear");
		$widgets->{'mencoder_output_table'}->attach($widgets->{'mencoder_output_clear_button'}, 2, 3, 0, 1, ['fill', 'expand'], [], 2, 2);

		$widgets->{'mencoder_output_saveall_button'} = new_with_label Gtk::ToggleButton("Continual save");
		$widgets->{'mencoder_output_table'}->attach($widgets->{'mencoder_output_saveall_button'}, 1, 2, 0, 1, ['fill', 'expand'], [], 2, 2);
	
		$widgets->{'mencoder_output_hide_button'} = new Gtk::Button("Hide debug");
		$widgets->{'mencoder_output_table'}->attach($widgets->{'mencoder_output_hide_button'}, 3, 4, 0, 1, ['fill', 'expand'], [], 2, 2);
		
		# Construct an mencoder output text
		$widgets->{'mencoder_output_text'} = new Gtk::Text;
		$widgets->{'mencoder_output_scroll'} = new Gtk::ScrolledWindow(undef, undef);
		$widgets->{'mencoder_output_scroll'}->set_policy('never', 'always');
		$widgets->{'mencoder_output_scroll'}->set_usize(0, 100);
		$widgets->{'mencoder_output_scroll'}->add($widgets->{'mencoder_output_text'});
		$widgets->{'mencoder_output_scroll'}->show;
		$widgets->{'output_vbox'}->pack_start($widgets->{'mencoder_output_scroll'}, 1, 1, 2);
		$widgets->{'mencoder_output_text'}->show;
		$widgets->{'mencoder_output_text'}->set_line_wrap(1);

### STATUS BAR
		
  	# Construct a GtkStatusbar
		$widgets->{'status_hbox'} = new Gtk::HBox;
		$widgets->{'status_hbox'}->show;
		$widgets->{'status_vbox'}->add($widgets->{'status_hbox'});
  	$widgets->{'status_bar'} = new Gtk::Statusbar;
  	$widgets->{'status_hbox'}->pack_start($widgets->{'status_bar'}, 1, 1, 2);
  	$widgets->{'status_bar'}->show;

		# Construct hide/show mencoder output button
		$widgets->{'mencoder_output_show_button'} = new Gtk::Button;
		$widgets->{'mencoder_output_show_hbox'} = new Gtk::HBox;
		$widgets->{'mencoder_output_show_hbox'}->pack_start(new Gtk::Label('Debug'), 0, 0, 2);
		$widgets->{'mencoder_output_show_hbox'}->pack_end(new Gtk::Arrow('down', 'out'), 0, 0, 2);
		$widgets->{'mencoder_output_show_button'}->add($widgets->{'mencoder_output_show_hbox'});
		$widgets->{'mencoder_output_show_button'}->show_all;
		$widgets->{'status_hbox'}->pack_end($widgets->{'mencoder_output_show_button'}, 0, 1, 2	);
    
### COMPACT DIALOG
		
    $widgets->{'progress_dialog'} = new Gtk::Dialog;
    $widgets->{'progress_dialog'}->set_title('acidrip');
    $widgets->{'progress_dialog'}->position('center');
    $widgets->{'progress_dialog'}->set_policy(0, 0, 1);
    $widgets->{'progress_dialog'}->set_modal(1);
    $widgets->{'progress_dialog'}->realize;
	 
		# Construct a GtkVBox 'additional_settings_vbox'
		$widgets->{'progress_vbox'} = $widgets->{'progress_dialog'}->vbox;
		$widgets->{'progress_vbox'}->show;
		
	  # Construct a GtkHBox 'additional_settings_action_area'
	  $widgets->{'progress_action_area'} = $widgets->{'progress_dialog'}->action_area;
	  $widgets->{'progress_action_area'}->show;
	  $widgets->{'progress_action_area'}->border_width(10);
		
		$widgets->{'progress_dialog_hide_button'} = new Gtk::Button("Full view");
		$widgets->{'progress_dialog_hide_button'}->show;
		$widgets->{'progress_action_area'}->pack_end($widgets->{'progress_dialog_hide_button'}, 0, 1, 0);
	  		
### TRACK TREE

		$widgets->{'track_tree'} = new Gtk::Tree;

### TOOLTIPS		

		$widgets->{'tooltips'} = new Gtk::Tooltips();
		$widgets->{'tooltips'}->set_tip($widgets->{'scale_width_spin'}, "Width of the video output, default 480, smaller width will encode faster.");
		$widgets->{'tooltips'}->set_tip($widgets->{'scale_height_spin'}, "Height of the video output, default -2: calculates aspect based on crop and dvd information");
		$widgets->{'tooltips'}->set_tip($widgets->{'crop_width_spin'}, "Width of the crop, relative to original dvd video stream");
		$widgets->{'tooltips'}->set_tip($widgets->{'crop_height_spin'}, "Height of the crop, relative to the original dvd video stream");
		$widgets->{'tooltips'}->set_tip($widgets->{'crop_vertical_spin'}, "Vertical offset from top of video");
		$widgets->{'tooltips'}->set_tip($widgets->{'crop_horizontal_spin'}, "Horizontal offset from left side of video");
		$widgets->{'tooltips'}->set_tip($widgets->{'crop_enable_check'}, "Turn cropping on/off");
		$widgets->{'tooltips'}->set_tip($widgets->{'scale_enable_check'}, "Turn video scaling on/off");
		$widgets->{'tooltips'}->set_tip($widgets->{'crop_detect_button'}, "Detect optimum crop values");
		$widgets->{'tooltips'}->set_tip($widgets->{'video_codec_entry'}, "Video output format to be used");
		$widgets->{'tooltips'}->set_tip($widgets->{'video_options_entry'}, "Options specific to the selected video output");
		$widgets->{'tooltips'}->set_tip($widgets->{'video_bitrate_entry'}, "Bitrate calculated to satify filesize. can be edited if desired");
		$widgets->{'tooltips'}->set_tip($widgets->{'subp_entry'}, "Subpicture to be used");
		$widgets->{'tooltips'}->set_tip($widgets->{'read_dvd_button'}, "Load the dvd");
		$widgets->{'tooltips'}->set_tip($widgets->{'video_2pass_check'}, "Enable 2 pass encoding. This will, of course, take twice as long, but should provide noticeably better quality.");
		$widgets->{'tooltips'}->set_tip($widgets->{'dvd_device_entry'}, "Location of the DVD device");
		$widgets->{'tooltips'}->set_tip($widgets->{'directory_entry'}, "Prefix for output file, typically a directory path e.g \"/film/\", but could include file prefix too if you felt like it.");
		$widgets->{'tooltips'}->set_tip($widgets->{'autoload_check'}, "Automatically load DVD and crop (if enabled) when program is loaded. (Remember to save settings!)");
		$widgets->{'tooltips'}->set_tip($widgets->{'overwrite_check'}, "Overwrite files if they already exist... woahh careful!");
		$widgets->{'tooltips'}->set_tip($widgets->{'audio_codec_entry'}, "Audio output format to be used");
		$widgets->{'tooltips'}->set_tip($widgets->{'audio_options_entry'}, "Options specific to selected video output");
		$widgets->{'tooltips'}->set_tip($widgets->{'audio_track_entry'}, "Audio track to use");
		$widgets->{'tooltips'}->set_tip($widgets->{'filename_entry'}, "Name of output file.");
		$widgets->{'tooltips'}->set_tip($widgets->{'filesize_spin'}, "Desired size of file(s), select typical values, or enter your own. If value is RED then you do not have enough space in the given location.");
		$widgets->{'tooltips'}->set_tip($widgets->{'save_button'}, "Store useful settings in $ENV{HOME}/.acidriprc");
		$widgets->{'tooltips'}->set_tip($widgets->{'restore_button'}, "Restore default settings");
		$widgets->{'tooltips'}->set_tip($widgets->{'start_button'}, "Begin encoding with current settings");
		$widgets->{'tooltips'}->set_tip($widgets->{'stop_button'}, "Stop encoding");
		$widgets->{'tooltips'}->set_tip($widgets->{'view_button'}, "Play back output file");
		$widgets->{'tooltips'}->set_tip($widgets->{'track_tree'}, "Contents of currently loaded DVD");
		$widgets->{'tooltips'}->set_tip($widgets->{'mencoder_output_show_button'}, "Show lots of lovely information about what's going on, useful for troubleshooting.");
		$widgets->{'tooltips'}->set_tip($widgets->{'mencoder_output_hide_button'}, "Hide all of this junk...");
		$widgets->{'tooltips'}->set_tip($widgets->{'mencoder_output_save_button'}, "Save all output information to $ENV{HOME}/acidrip.log.");
		$widgets->{'tooltips'}->set_tip($widgets->{'video_bitrate_lock_check'}, "Lock bitrate from automatic updating");
		$widgets->{'tooltips'}->set_tip($widgets->{'scale_lock_check'}, "Lock height relative to width");
		$widgets->{'tooltips'}->set_tip($widgets->{'mencoder_output_clear_button'}, "Clear all output information");
		$widgets->{'tooltips'}->set_tip($widgets->{'video_bpp_entry'}, "Estimated bits per pixel. Ideally you want to hit around 0.25 with a decent divx codec");
		$widgets->{'tooltips'}->set_tip($widgets->{'more_options_entry'}, "Somewhere for any other options to go that are not handled here");
		$widgets->{'tooltips'}->set_tip($widgets->{'total_blocks_spin'}, "Automatically split dvd into a given number of files by chapter boundaries");
		$widgets->{'tooltips'}->set_tip($widgets->{'mencoder_entry'}, "Specify a set location for mencoder or similar, e.g. \"/mnt/nfs/usr/bin/mencoder\" or even \"nice mencoder\"");
		$widgets->{'tooltips'}->set_tip($widgets->{'language_entry'}, "Set preferred language for audio, reload DVD to take effect.");
		$widgets->{'tooltips'}->set_tip($widgets->{'cache_directory_entry'}, "Specify a set location for caching the DVD title to, e.g. \"/tmp\". You do NOT need to cache the dvd.");
		$widgets->{'tooltips'}->set_tip($widgets->{'cache_check'}, "To cache or not to cache. Useful if you're impatient and can\'t leave the disc for more than 30 mins... other than that...");
		$widgets->{'tooltips'}->set_tip($widgets->{'compact_check'}, "Show only encoding status when encoding title, smaller and less chance of accidentally stopping it!");
		$widgets->{'tooltips'}->set_tip($widgets->{'enforce_space_check'}, "Refuse to encode if there appears to not be enough space in output directory (encoding only, not caching)");
		$widgets->{'tooltips'}->set_tip($widgets->{'vop_pre_enable_check'}, "vop options to apply to video before cropping / scaling - see mplayer docs");
		$widgets->{'tooltips'}->set_tip($widgets->{'vop_post_enable_check'}, "vop options to apply to video after cropping / scaling - see mplayer docs");
		$widgets->{'tooltips'}->set_tip($widgets->{'info_field_combo'}, "Set various attributes with the avi file. Few players besides MPlayer use this information.");
		$widgets->{'tooltips'}->set_tip($widgets->{'ppc_bug_check'}, "Mencoder\'s -sstep option doesn't work on PPC, use alternate (less reliable) crop method");
		$widgets->{'tooltips'}->set_tip($widgets->{'flickbook_preview_check'}, "Previews film with selected still shots instead of entire playback (not possible if using ppc bug)");
		$widgets->{'tooltips'}->set_tip($widgets->{'vobsubout_check'}, "Dump subtitles to seperate file instead of rendering directly to the video.");
    $widgets->{'tooltips'}->set_tip($widgets->{'embed_preview_check'}, "Show preview in space above, rather than a full size detached window");
		
		$widgets->{'preview_button'}->signal_connect							('clicked', \&on_crop_preview_button_clicked);
		$widgets->{'track_tree'}->signal_connect									('select-child', \&on_select_track);
		$widgets->{'crop_detect_button'}->signal_connect  	 		  ('clicked', \&on_crop_detect_button_clicked);
		$widgets->{'save_button'}->signal_connect									('clicked', \&on_save_settings_button_clicked);
		$widgets->{'restore_button'}->signal_connect							('clicked', \&on_restore_defaults_button_clicked);
		$widgets->{'start_button'}->signal_connect								('clicked', \&on_start_button_clicked);
		$widgets->{'stop_button'}->signal_connect									('clicked', \&on_stop_button_clicked);
		$widgets->{'stop_preview_button'}->signal_connect					('clicked', \&on_stop_button_clicked);
		$widgets->{'view_button'}->signal_connect									('clicked', \&on_view_button_clicked);
		$widgets->{'video_bitrate_lock_check'}->signal_connect		('toggled', \&on_video_bitrate_lock_check_clicked);
		$widgets->{'scale_lock_check'}->signal_connect					  ('toggled', \&on_scale_lock_check_clicked);

		$widgets->{'mencoder_output_save_button'}->signal_connect	('clicked', \&on_mencoder_output_save_button_clicked);
		$widgets->{'mencoder_output_clear_button'}->signal_connect('clicked', \&on_mencoder_output_clear_button_clicked);
		$widgets->{'mencoder_output_show_button'}->signal_connect	('clicked', \&on_mencoder_output_show_button_clicked);
		$widgets->{'mencoder_output_hide_button'}->signal_connect	('clicked', \&on_mencoder_output_hide_button_clicked);
		$widgets->{'mencoder_output_saveall_button'}->signal_connect ('clicked', \&on_mencoder_output_saveall_button_clicked);

		bless ($widgets, $class);

		$widgets->connect_signals('toggled', \&on_setting_finished, 'tooltips_check', 'cache_check', 'autoload_check', 'crop_enable_check',
			'video_2pass_check', 'scale_enable_check', 'overwrite_check', 'vop_pre_enable_check', 'vop_post_enable_check', 'del_cache_check',
		  'enforce_space_check', 'compact_check', 'ppc_bug_check', 'flickbook_preview_check', 'vobsubout_check', 'embed_preview_check');
		$widgets->connect_signals('changed', \&on_setting_changed, 'filesize_spin', 'video_codec_entry', 'audio_codec_entry', 'crop_height_spin',
			'scale_width_spin', 'scale_height_spin', 'total_blocks_spin', 'crop_width_spin', 'crop_vertical_spin', 'crop_horizontal_spin',
		  'info_field_entry', 'filename_entry', 'directory_entry');
		$widgets->connect_signals('changed', \&on_setting_finished, 'total_blocks_spin', 'video_codec_entry', 'audio_codec_entry',
			'vop_pre_entry', 'vop_post_entry');
		$widgets->connect_signals('focus_out_event', \&on_setting_finished, 'mplayer_entry', 'lsdvd_entry', 'mencoder_entry', 'video_bitrate_entry',
			'crop_height_spin', 'more_options_entry', 'crop_width_spin', 'crop_vertical_spin', 'crop_horizontal_spin', 'dvd_device_entry', 'language_entry',
			'directory_entry', 'video_options_entry', 'filename_entry', 'audio_options_entry', 'scale_width_spin', 'scale_height_spin', 'info_name_entry',
		  'info_artist_entry', 'info_subject_entry', 'info_genre_entry', 'info_copyright_entry', 'info_comment_entry', 
		  'cache_directory_entry', 'directory_filename_entry', 'filesize_spin');

		$widgets->{'mencoder_output_text'}->signal_connect					('changed', sub {$widgets->{'mencoder_output_text'}->set_point($::widgets->{'mencoder_output_text'}->get_length)});
		$widgets->{'video_bpp_entry'}->signal_connect								('changed', \&on_bpp_changed);
		$widgets->{'filesize_spin'}->signal_connect									('changed', \&on_filesize_changed);

		$widgets->{'read_dvd_button'}->signal_connect								('clicked', \&on_read_dvd_button_clicked, $widgets);

		$widgets->{'acidrip'}->signal_connect         	      		  ('delete_event', \&quit_acidrip);
		$widgets->{'quit_button'}->signal_connect      		     			('clicked', \&quit_acidrip);
		$widgets->{'progress_dialog_hide_button'}->signal_connect  	('clicked', \&progress_dialog_hide);
		$widgets->{'progress_dialog_show_button'}->signal_connect  	('clicked', \&progress_dialog_show);

		
		##################################################
		# NB subp and audio combo connects in signals.pm #
		##################################################
		
	Gtk->idle_add( sub {while (Gtk->events_pending()) {Gtk->main_iteration()}});
	
  return $widgets;
} 

1;
